From a3ac4676bb34fcd9947b3d6cb194fc0d904814d5 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Lo=C3=AFc=20Dachary?= <ldachary@easter-eggs.com>
Date: Thu, 4 Mar 2021 14:22:19 +0100
Subject: [PATCH] doc: add a reference to the release cycle (#51668)

* add a link to the release cycle in the installation section
* update python and django versions
* remove obsolete instructions
* move the issue tracker to the section in which it belongs
* fix a typo

Fixes: #51668

License: MIT
---
 doc/installation.rst       |  9 +++-
 doc/installation_modes.rst | 85 +++++---------------------------------
 doc/overview.rst           | 10 ++---
 3 files changed, 23 insertions(+), 81 deletions(-)

diff --git a/doc/installation.rst b/doc/installation.rst
index d94be8045..5e9a293d1 100644
--- a/doc/installation.rst
+++ b/doc/installation.rst
@@ -5,9 +5,9 @@ Installation and quickstart tutorials
 =====================================
 
 You'll find here how to start and configure very quickly Authentic 2 for its
-main features. You just need Python 2.7 and Django 1.5.
+main features. You just need Python 3 and Django 2.2.
 
-First of all, you can boot Authentic vwithout root
+First of all, you can boot Authentic without root
 privileges  like this:
 
 1. Initialize a virtualenv::
@@ -28,6 +28,11 @@ privileges  like this:
 
     authentic2-ctl runserver
 
+Release cycle
+-------------
+
+The release cycle of Authentic follows the `release cycle of Publik <https://dev.entrouvert.org/projects/publik/wiki/Cycle_de_mises_%C3%A0_jour>`__.
+
 Quickstart guides and installation guidelines
 ---------------------------------------------
 
diff --git a/doc/installation_modes.rst b/doc/installation_modes.rst
index 9912a5ddd..1894c0e42 100644
--- a/doc/installation_modes.rst
+++ b/doc/installation_modes.rst
@@ -4,7 +4,7 @@
 Installation modes
 ==================
 
-The current version of Authentic 2 works with Python 2.7 and Django 1.5.
+The current version of Authentic 2 works with Python 3 and Django 1.11 or 2.2.
 
 Authentic 2 python installation script handles all the dependencies,
 except Lasso, relying on the Setuptools and the pypi repository.
@@ -12,21 +12,6 @@ except Lasso, relying on the Setuptools and the pypi repository.
 To run Authentic 2 with SAML2 features, you need to install lasso >= 2.3.6,
 see :ref:`install-lasso-ref`.
 
-The other Authentic 2 dependencies are:
-
-- Django>=1.7.6,<1.9
-- requests>=2.
-- django-model-utils>=2
-- dnspython>=1.12
-- django-select2>=4.3.0
-- django-tables2>=1.0
-- gadjo>=0.6
-- django-import-export>=0.2.7,<=0.4.5
-- djangorestframework>=3.3
-- six>=1.9
-- Markdown>=2.5
-- python-ldap
-
 Install Authentic 2:
 
 - :ref:`install-pypi-ref`
@@ -50,69 +35,21 @@ We also provide rpm packages for redhat, see https://dev.entrouvert.org/redhat/R
 You can also install lasso from sources  http://lasso.entrouvert.org/download
 
 See the `Lasso website <http://lasso.entrouvert.org>`_ for installation details.
-This is a quick installation example.
-
-Install the following Lasso dependencies:
-
-- autoconf
-- automake
-- autotools-dev
-- libtool
-- gtk-doc-tools
-- zlib1g-dev
-- libglib2.0-dev
-- openssl-dev
-- libxml2-dev
-- libxmlsec1-dev
-- python2.6-dev
-- python-setuptools
-
-Obtain Lasso::
-
-  $wget https://dev.entrouvert.org/lasso/lasso-2.3.6.tar.gz
-  $tar xzvf lasso-2.3.6.tar.gz
-  $cd lasso-2.3.6
-  $./autogen.sh
-
-Be sure that the Python bindings is selected as follows::
-
-    =============
-    Configuration
-    =============
-
-    Main
-    ----
-
-    Compiler:                gcc
-    CFLAGS:
-    Install prefix:          /usr/local
-    Debugging:               no
-    Experimental ID-WSF:     no
+This is a quick installation example. Obtain Lasso::
 
-    Optionals builds
-    ----------------
-
-    Available languages:    java(4.6.1) python(2.7) perl(5.12.4)
-
-    Java binding:           yes
-    Perl binding:           yes
-    PHP 5 binding:          no
-    Python binding:         yes
-
-    C API references:       yes
-    Tests suite:            no
-
-
-    Now type 'make install' to install lasso.
+  $wget https://dev.entrouvert.org/lasso/lasso-2.6.1.tar.gz
+  $tar xzvf lasso-2.6.1.tar.gz
+  $cd lasso-2.6.1
+  $./autogen.sh
 
-As indicated, build and install::
+Build and install::
 
   $make install
   $ldconfig
 
 Set the lasso python binding in you python path, e.g.::
 
-  $export PYTHONPATH="$PYTHONPATH:/usr/local/lib/python2.6/site-packages"
+  $export PYTHONPATH="$PYTHONPATH:/usr/local/lib/python3.8/site-packages"
 
 Test trying to import Lasso::
 
@@ -138,7 +75,7 @@ You should see the following output::
   Validating models...
   0 errors found
 
-  Django version 1.5, using settings 'authentic.settings'
+  Django version 2.2, using settings 'authentic.settings'
   Development server is running at http://127.0.0.1:8000/
   Quit the server with CONTROL-C.
 
@@ -165,7 +102,7 @@ You should see the following output::
   Validating models...
   0 errors found
 
-  Django version 1.5, using settings 'authentic.settings'
+  Django version 2.2, using settings 'authentic.settings'
   Development server is running at http://127.0.0.1:8000/
   Quit the server with CONTROL-C.
 
@@ -195,7 +132,7 @@ You should see the following output::
   Validating models...
   0 errors found
 
-  Django version 1.5, using settings 'authentic.settings'
+  Django version 2.2, using settings 'authentic.settings'
   Development server is running at http://127.0.0.1:8000/
   Quit the server with CONTROL-C.
 
diff --git a/doc/overview.rst b/doc/overview.rst
index e95e89402..385354fb6 100644
--- a/doc/overview.rst
+++ b/doc/overview.rst
@@ -17,7 +17,7 @@ It has support for SAMLv2 thanks to `Lasso <http://lasso.entrouvert.org>`_,
 a free (GNU GPL) implementation of the Liberty Alliance and OASIS
 specifications of SAML2.
 
-Authentic 2 requires Python 2.7 et Django 1.5.
+Authentic 2 is tested with Python 3, Django 1.11 and Django 2.2, DRF 3.4 and DRF 3.9
 
 Features
 --------
@@ -48,11 +48,11 @@ You can find there a viewer of the git repository or clone it::
 
     git clone http://repos.entrouvert.org/authentic.git
 
+You can open reports or feature request on https://dev.entrouvert.org/projects/authentic/issues.
+
 Support
 -------
 Authentic's developpers and users hangs on the mailing list authentic@listes.entrouvert.com.
-See archives or register at http://listes.entrouvert.com/info/authentic.
-
-You can open reports or feature request on http://authentic.entrouvert.org.
+See archives or register at https://listes.entrouvert.com/info/authentic.
 
-Entr'ouvert also provides a commercial support. For information, visit http://www.entrouvert.com.
+Entr'ouvert also provides a commercial support. For information, visit https://www.entrouvert.com.
-- 
2.25.1