From e0f04e67186a68f6a8ab68033ae7cf8895a3c165 Mon Sep 17 00:00:00 2001
From: Nicolas ROCHE <nroche@entrouvert.com>
Date: Fri, 5 Mar 2021 18:44:14 +0100
Subject: [PATCH] greco: update wdsl in tests (#51735)

---
 tests/data/greco/greco.wsdl | 144 ++++++++++++++++++++++++++----------
 1 file changed, 104 insertions(+), 40 deletions(-)

diff --git a/tests/data/greco/greco.wsdl b/tests/data/greco/greco.wsdl
index 31bd915a..dcb3f000 100644
--- a/tests/data/greco/greco.wsdl
+++ b/tests/data/greco/greco.wsdl
@@ -1,16 +1,14 @@
-<?xml version="1.0"?>
-<wsdl:definitions xmlns:apachesoap="http://xml.apache.org/xml-soap" xmlns:impl="http://mairies.services.external.coheris.com" xmlns:intf="http://mairies.services.external.coheris.com" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:wsdlsoap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" targetNamespace="http://mairies.services.external.coheris.com">
-  <!--
-WSDL created by Apache Axis version: 1.4
-Built on Apr 22, 2006 (06:55:48 PDT)
--->
+<?xml version="1.0" encoding="UTF-8"?>
+<wsdl:definitions targetNamespace="http://mairies.services.external.coheris.com" xmlns:apachesoap="http://xml.apache.org/xml-soap" xmlns:impl="http://mairies.services.external.coheris.com" xmlns:intf="http://mairies.services.external.coheris.com" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:wsdlsoap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
+  <!--WSDL created by Apache Axis version: 1.4
+Built on Apr 22, 2006 (06:55:48 PDT)-->
   <wsdl:types>
-    <schema xmlns="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified" targetNamespace="http://mairies.services.external.coheris.com">
+    <schema elementFormDefault="qualified" targetNamespace="http://mairies.services.external.coheris.com" xmlns="http://www.w3.org/2001/XMLSchema">
       <element name="ajouterComplementInformation">
         <complexType>
           <sequence>
             <element name="demandeAjoutComplementInfo" type="impl:DemandeAjoutComplementInfo"/>
           </sequence>
         </complexType>
       </element>
       <complexType name="DemandeAjoutComplementInfo">
@@ -94,19 +92,26 @@ Built on Apr 22, 2006 (06:55:48 PDT)
       </complexType>
       <element name="consulterResponse">
         <complexType>
           <sequence>
             <element name="consulterReturn" type="impl:ReponseConsultation"/>
           </sequence>
         </complexType>
       </element>
+      <complexType name="ReponseConfirmation">
+        <sequence>
+          <element name="iddemande" nillable="true" type="xsd:string"/>
+          <element name="idgreco" nillable="true" type="xsd:string"/>
+          <element name="motifsrejet" nillable="true" type="xsd:string"/>
+        </sequence>
+      </complexType>
       <complexType name="ReponseEtat">
         <complexContent>
-          <extension base="impl:Reponse">
+          <extension base="impl:ReponseConfirmation">
             <sequence>
               <element name="etat" nillable="true" type="xsd:string"/>
             </sequence>
           </extension>
         </complexContent>
       </complexType>
       <complexType name="CompteRendu">
         <sequence>
@@ -287,28 +292,45 @@ Built on Apr 22, 2006 (06:55:48 PDT)
         </sequence>
       </complexType>
       <complexType name="VoieSecante">
         <sequence>
           <element name="codeRivoliVoieSecante" nillable="true" type="xsd:string"/>
           <element name="codeFuvVoieSecante" nillable="true" type="xsd:string"/>
         </sequence>
       </complexType>
+      <complexType name="PieceJointe">
+        <sequence>
+          <element name="nom" nillable="true" type="xsd:string"/>
+          <element name="contenu" nillable="true" type="xsd:string"/>
+        </sequence>
+      </complexType>
+      <complexType name="ArrayOfPiecesJointes">
+        <sequence>
+          <element maxOccurs="unbounded" minOccurs="0" name="pieceJointe" type="impl:PieceJointe"/>
+        </sequence>
+      </complexType>
       <complexType name="GetContenuDossierResponse">
         <complexContent>
           <extension base="impl:ReponseEtat">
             <sequence>
               <element name="dateDeDepot" nillable="true" type="xsd:string"/>
               <element name="mediaDeReponse" nillable="true" type="xsd:string"/>
               <element name="description" nillable="true" type="xsd:string"/>
               <element name="isDangerRsque" nillable="true" type="xsd:string"/>
               <element name="beneficiaireContact" nillable="true" type="impl:BeneficiaireContact"/>
               <element name="beneficiaireAdresse" nillable="true" type="impl:BeneficiaireAdresse"/>
               <element name="localisationV2" nillable="true" type="impl:LocalisationV2"/>
               <element name="voieSecante" nillable="true" type="impl:VoieSecante"/>
+              <element name="idDomaineObjetType" nillable="true" type="xsd:string"/>
+              <element name="libelleDomaineObjetType" nillable="true" type="xsd:string"/>
+              <element name="natureDemande" nillable="true" type="xsd:string"/>
+              <element name="modeReception" nillable="true" type="xsd:string"/>
+              <element name="dateResolutionTheorique" nillable="true" type="xsd:string"/>
+              <element name="piecesJointes" nillable="true" type="impl:ArrayOfPiecesJointes"/>
             </sequence>
           </extension>
         </complexContent>
       </complexType>
       <element name="creer">
         <complexType>
           <sequence>
             <element name="demandeCreation" type="impl:DemandeCreation"/>
@@ -349,16 +371,18 @@ Built on Apr 22, 2006 (06:55:48 PDT)
           <element name="codefuvvoiesecante" nillable="true" type="xsd:string"/>
           <element name="coderivolivoie" nillable="true" type="xsd:string"/>
           <element name="coderivolivoiesecante" nillable="true" type="xsd:string"/>
           <element name="commune" nillable="true" type="xsd:string"/>
           <element name="complement" nillable="true" type="xsd:string"/>
           <element name="numerovoie" nillable="true" type="xsd:string"/>
           <element name="voie" nillable="true" type="xsd:string"/>
           <element name="voiesecante" nillable="true" type="xsd:string"/>
+          <element name="xgeoloc" nillable="true" type="xsd:string"/>
+          <element name="ygeoloc" nillable="true" type="xsd:string"/>
         </sequence>
       </complexType>
       <complexType name="Transmetteur">
         <complexContent>
           <extension base="impl:Contact">
             <sequence>
               <element name="service" nillable="true" type="xsd:string"/>
             </sequence>
@@ -392,78 +416,105 @@ Built on Apr 22, 2006 (06:55:48 PDT)
         <complexContent>
           <extension base="impl:ReponseEtat">
             <sequence>
               <element name="application" nillable="true" type="xsd:string"/>
             </sequence>
           </extension>
         </complexContent>
       </complexType>
+      <element name="confirmer">
+        <complexType>
+          <sequence>
+            <element name="demandeConfirmation" type="impl:DemandeConfirmation"/>
+          </sequence>
+        </complexType>
+      </element>
+      <complexType name="DemandeConfirmation">
+        <sequence>
+          <element name="nbconfirmation" nillable="true" type="xsd:string"/>
+          <element name="idDemande" nillable="true" type="xsd:string"/>
+          <element name="idGreco" nillable="true" type="xsd:string"/>
+        </sequence>
+      </complexType>
+      <element name="confirmerResponse">
+        <complexType>
+          <sequence>
+            <element name="confirmerReturn" type="impl:ReponseConfirmation"/>
+          </sequence>
+        </complexType>
+      </element>
     </schema>
   </wsdl:types>
-  <wsdl:message name="getListOrganismeResponse">
-    <wsdl:part element="impl:getListOrganismeResponse" name="parameters"/>
-  </wsdl:message>
-  <wsdl:message name="ajouterComplementInformationRequest">
-    <wsdl:part element="impl:ajouterComplementInformation" name="parameters"/>
-  </wsdl:message>
-  <wsdl:message name="getListDemandeRequest">
-    <wsdl:part element="impl:getListDemande" name="parameters"/>
+  <wsdl:message name="confirmerRequest">
+    <wsdl:part element="impl:confirmer" name="parameters"/>
   </wsdl:message>
   <wsdl:message name="getContenuDossierRequest">
     <wsdl:part element="impl:getContenuDossier" name="parameters"/>
   </wsdl:message>
-  <wsdl:message name="relancerRequest">
-    <wsdl:part element="impl:relancer" name="parameters"/>
+  <wsdl:message name="getListDemandeResponse">
+    <wsdl:part element="impl:getListDemandeResponse" name="parameters"/>
+  </wsdl:message>
+  <wsdl:message name="getContenuDossierResponse">
+    <wsdl:part element="impl:getContenuDossierResponse" name="parameters"/>
+  </wsdl:message>
+  <wsdl:message name="getListDemandeRequest">
+    <wsdl:part element="impl:getListDemande" name="parameters"/>
   </wsdl:message>
   <wsdl:message name="creerRequest">
     <wsdl:part element="impl:creer" name="parameters"/>
   </wsdl:message>
-  <wsdl:message name="getListOrganismeRequest">
-    <wsdl:part element="impl:getListOrganisme" name="parameters"/>
+  <wsdl:message name="confirmerResponse">
+    <wsdl:part element="impl:confirmerResponse" name="parameters"/>
+  </wsdl:message>
+  <wsdl:message name="attachmentTestRequest">
+    <wsdl:part element="impl:attachmentTest" name="parameters"/>
+  </wsdl:message>
+  <wsdl:message name="ajouterComplementInformationRequest">
+    <wsdl:part element="impl:ajouterComplementInformation" name="parameters"/>
+  </wsdl:message>
+  <wsdl:message name="getListOrganismeResponse">
+    <wsdl:part element="impl:getListOrganismeResponse" name="parameters"/>
   </wsdl:message>
   <wsdl:message name="communicationTestRequest">
     <wsdl:part element="impl:communicationTest" name="parameters"/>
   </wsdl:message>
-  <wsdl:message name="relancerResponse">
-    <wsdl:part element="impl:relancerResponse" name="parameters"/>
-  </wsdl:message>
   <wsdl:message name="ajouterComplementInformationResponse">
     <wsdl:part element="impl:ajouterComplementInformationResponse" name="parameters"/>
   </wsdl:message>
-  <wsdl:message name="getContenuDossierResponse">
-    <wsdl:part element="impl:getContenuDossierResponse" name="parameters"/>
+  <wsdl:message name="relancerRequest">
+    <wsdl:part element="impl:relancer" name="parameters"/>
   </wsdl:message>
-  <wsdl:message name="attachmentTestResponse">
-    <wsdl:part element="impl:attachmentTestResponse" name="parameters"/>
+  <wsdl:message name="getMailRequest">
+    <wsdl:part element="impl:getMail" name="parameters"/>
+  </wsdl:message>
+  <wsdl:message name="getListOrganismeRequest">
+    <wsdl:part element="impl:getListOrganisme" name="parameters"/>
   </wsdl:message>
   <wsdl:message name="consulterRequest">
     <wsdl:part element="impl:consulter" name="parameters"/>
   </wsdl:message>
-  <wsdl:message name="attachmentTestRequest">
-    <wsdl:part element="impl:attachmentTest" name="parameters"/>
-  </wsdl:message>
   <wsdl:message name="creerResponse">
     <wsdl:part element="impl:creerResponse" name="parameters"/>
   </wsdl:message>
-  <wsdl:message name="getListDemandeResponse">
-    <wsdl:part element="impl:getListDemandeResponse" name="parameters"/>
-  </wsdl:message>
-  <wsdl:message name="getMailRequest">
-    <wsdl:part element="impl:getMail" name="parameters"/>
-  </wsdl:message>
   <wsdl:message name="communicationTestResponse">
     <wsdl:part element="impl:communicationTestResponse" name="parameters"/>
   </wsdl:message>
-  <wsdl:message name="consulterResponse">
-    <wsdl:part element="impl:consulterResponse" name="parameters"/>
-  </wsdl:message>
   <wsdl:message name="getMailResponse">
     <wsdl:part element="impl:getMailResponse" name="parameters"/>
   </wsdl:message>
+  <wsdl:message name="attachmentTestResponse">
+    <wsdl:part element="impl:attachmentTestResponse" name="parameters"/>
+  </wsdl:message>
+  <wsdl:message name="relancerResponse">
+    <wsdl:part element="impl:relancerResponse" name="parameters"/>
+  </wsdl:message>
+  <wsdl:message name="consulterResponse">
+    <wsdl:part element="impl:consulterResponse" name="parameters"/>
+  </wsdl:message>
   <wsdl:portType name="Mairies">
     <wsdl:operation name="ajouterComplementInformation">
       <wsdl:input message="impl:ajouterComplementInformationRequest" name="ajouterComplementInformationRequest"/>
       <wsdl:output message="impl:ajouterComplementInformationResponse" name="ajouterComplementInformationResponse"/>
     </wsdl:operation>
     <wsdl:operation name="attachmentTest">
       <wsdl:input message="impl:attachmentTestRequest" name="attachmentTestRequest"/>
       <wsdl:output message="impl:attachmentTestResponse" name="attachmentTestResponse"/>
@@ -495,16 +546,20 @@ Built on Apr 22, 2006 (06:55:48 PDT)
     <wsdl:operation name="getContenuDossier">
       <wsdl:input message="impl:getContenuDossierRequest" name="getContenuDossierRequest"/>
       <wsdl:output message="impl:getContenuDossierResponse" name="getContenuDossierResponse"/>
     </wsdl:operation>
     <wsdl:operation name="creer">
       <wsdl:input message="impl:creerRequest" name="creerRequest"/>
       <wsdl:output message="impl:creerResponse" name="creerResponse"/>
     </wsdl:operation>
+    <wsdl:operation name="confirmer">
+      <wsdl:input message="impl:confirmerRequest" name="confirmerRequest"/>
+      <wsdl:output message="impl:confirmerResponse" name="confirmerResponse"/>
+    </wsdl:operation>
   </wsdl:portType>
   <wsdl:binding name="MairiesSoapBinding" type="impl:Mairies">
     <wsdlsoap:binding style="document" transport="http://schemas.xmlsoap.org/soap/http"/>
     <wsdl:operation name="ajouterComplementInformation">
       <wsdlsoap:operation soapAction=""/>
       <wsdl:input name="ajouterComplementInformationRequest">
         <wsdlsoap:body use="literal"/>
       </wsdl:input>
@@ -588,15 +643,24 @@ Built on Apr 22, 2006 (06:55:48 PDT)
       <wsdlsoap:operation soapAction=""/>
       <wsdl:input name="creerRequest">
         <wsdlsoap:body use="literal"/>
       </wsdl:input>
       <wsdl:output name="creerResponse">
         <wsdlsoap:body use="literal"/>
       </wsdl:output>
     </wsdl:operation>
+    <wsdl:operation name="confirmer">
+      <wsdlsoap:operation soapAction=""/>
+      <wsdl:input name="confirmerRequest">
+        <wsdlsoap:body use="literal"/>
+      </wsdl:input>
+      <wsdl:output name="confirmerResponse">
+        <wsdlsoap:body use="literal"/>
+      </wsdl:output>
+    </wsdl:operation>
   </wsdl:binding>
   <wsdl:service name="MairiesService">
     <wsdl:port binding="impl:MairiesSoapBinding" name="Mairies">
-      <wsdlsoap:address location="https://api.grandlyon.com/grc-pro/1.0.0"/>
+      <wsdlsoap:address location="http://grc-rec.grandlyon.fr/greco/services/Mairies"/>
     </wsdl:port>
   </wsdl:service>
 </wsdl:definitions>
-- 
2.30.1